package com.steerinfo.meterwork.meterworkimagetemp.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.meterwork.meterworkimagetemp.model.MeterWorkImageTemp;
import com.steerinfo.meterwork.meterworkimagetemp.service.IMeterWorkImageTempService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterWorkImageTemp RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-08-20 09:39
 * 类描述
 * 修订历史：
 * 日期：2022-08-20
 * 作者：generator
 * 参考：
 * 描述：MeterWorkImageTemp RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/meterworkimagetemps")
public class MeterWorkImageTempController extends BaseRESTfulController {

    @Autowired
    IMeterWorkImageTempService meterWorkImageTempService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkimagetemp:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterWorkImageTemp> list = meterWorkImageTempService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkimagetemp:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterWorkImageTemp> list = meterWorkImageTempService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据MeterWorkImageTemp对象创建")
    @ApiImplicitParam(name = "meterWorkImageTemp", value = "详细实体meterWorkImageTemp", required = true, dataType = "MeterWorkImageTemp")
    //@RequiresPermissions("meterworkimagetemp:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute MeterWorkImageTemp model){
        MeterWorkImageTemp meterWorkImageTemp = meterWorkImageTempService.add(model);
        return success(meterWorkImageTemp);
    }

    @ApiOperation(value = "动态轨道衡-C#图片创建", notes = "根据MeterWorkImageTemp对象创建")
    @ApiImplicitParam(name = "meterWorkImageTemp", value = "详细实体meterWorkImageTemp", required = true, dataType = "MeterWorkImageTemp")
    @PostMapping(value = "/doSaveRailwayWf", produces = "application/json;charset=UTF-8")
    public RESTfulResult doSaveRailwayWf(@RequestBody MeterWorkImageTemp model) {
        try {
            return meterWorkImageTempService.doSaveRailwayWf(model);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkimagetemp:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        MeterWorkImageTemp meterWorkImageTemp = meterWorkImageTempService.getById(id);
        return success(meterWorkImageTemp);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterWorkImageTemp信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "meterWorkImageTemp", value = "详细实体meterWorkImageTemp", required = true, dataType = "MeterWorkImageTemp")
    })
    //@RequiresPermissions("meterworkimagetemp:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterWorkImageTemp model){
        model.setId(id);
        MeterWorkImageTemp meterWorkImageTemp = meterWorkImageTempService.modify(model);
        return success(meterWorkImageTemp);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkimagetemp:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  meterWorkImageTempService.delete(ids);
    	}
      return success();
    }
}
